package com.zksy.controller.property;

import com.zksy.property.domain.ATenantManagement;
import com.zksy.property.service.ATenantManagementService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 租户信息管理控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/atenantManagement")
@Api(tags = "租户信息管理信息",description = "租户信息管理信息desc")
public class ATenantManagementController {
    @Autowired
    private ATenantManagementService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "租户信息管理信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String personalName,String companyName,String tenantStatus){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, personalName,companyName,tenantStatus));
    }
    @GetMapping("/getATenantManagementList")
    @ApiOperation(value = "租户信息管理信息查询")
    public AjaxResult getATenantManagementList(String personalName,String companyName,String tenantStatus){
        return AjaxResult.success(service.getATenantManagementList(personalName,companyName,tenantStatus));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询租户信息管理信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "租户信息管理信息保存")
    public AjaxResult save(@RequestBody ATenantManagement atenantManagement) {
        return service.save(atenantManagement) ? AjaxResult.success(atenantManagement) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "租户信息管理信息修改")

    public AjaxResult update(@RequestBody ATenantManagement atenantManagement) {
        atenantManagement.setUpdateTime(LocalDateTime.now());
        return service.updateById(atenantManagement) ? AjaxResult.success(atenantManagement) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "租户信息管理信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, ATenantManagement.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String personalName,String companyName,String tenantStatus) {
        ExcelExportUtil.exportExcel(response,service.getATenantManagementList(personalName,companyName,tenantStatus), ATenantManagement.class, "租户信息管理信息","租户信息管理信息");
    }

}
